#########
# Author:        gq1
# Maintainer:    $Author: gq1 $
# Created:       2008-09-30
# Last Modified: $Date: 2009-01-21 16:02:20 +0000 (Wed, 21 Jan 2009) $
# Id:            $Id: run_caching.pm 4034 2009-01-21 16:02:20Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/trunk/lib/npg_qc/api/run_caching.pm $
#
package npg_qc::api::run_caching;
use strict;
use warnings;
use Carp;
use English qw{-no_match_vars};
use base qw(npg_qc::api::base);



our $VERSION = do { my ($r) = q$LastChangedRevision: 4034 $ =~ /(\d+)/mxs; $r; };

sub cache_list_query_lane_summary{
  my ($self, $id_run_list) = @_;

  foreach my $id_run (@{$id_run_list}){
    eval{
      $self->cache_query_lane_summary($id_run, 1, 1);
      $self->cache_query_lane_summary($id_run, 2, 1);
      1;
    } or do {
      croak $EVAL_ERROR;
    };
  }
  return;
}

sub cache_list_query_movez_tiles{
  my ($self, $id_run_list) = @_;

  foreach my $id_run (@{$id_run_list}){
    eval{
      $self->cache_query_movez_tiles($id_run, 1);
      1;
    } or do {
      croak $EVAL_ERROR;
    };
  }
  return;
}

sub cache_list_query_run_graph{
  my ($self, $id_run_list) = @_;

  foreach my $id_run (@{$id_run_list}){
    eval{
      $self->run_graph($id_run, 1, 1);
      $self->run_graph($id_run, 2, 1);
      1;
    } or do {
      croak $EVAL_ERROR;
    };
  }
  return;
}
sub cache_all{

  my ($self, $id_run, $end, $to_update) = @_;

  if(!$end){
    $end =1;
  }
  if(!$to_update){
    $to_update = 0;
  }

  eval{
    if($id_run){
       $self->cache_query_lane_summary($id_run, $end, $to_update);
    }else{
      $self->cache_query_lane_summary();
    }
    1;
  } or do{
     carp $EVAL_ERROR;
  };

  eval{
    if($id_run){
      $self->cache_query_movez_tiles($id_run, $to_update);
    }else{
      $self->cache_query_movez_tiles();
    }
    1;
  } or do{
     carp $EVAL_ERROR;
  };

  eval{
    if($id_run){
       $self->run_graph($id_run, $end);
    }else{
      $self->run_graph();
    }
    1;
  } or do{
     carp $EVAL_ERROR;
  };

  eval{
    if($id_run){
       $self->instrument_statistics($id_run, $end);
    }else{
      $self->instrument_statistics();
    }
    1;
  } or do{
     carp $EVAL_ERROR;
  };

  return;
}

sub run_graph{

  my ($self, $id_run, $end) = @_;

  my $xml = q{<?xml version="1.0" encoding="utf-8"?><root><method>run_graph</method>};
  if($id_run){
    $xml .= q{<id_run};

    if($end){
      $xml .= qq{ end="$end"};
    }else{
      $xml .= q{ end="1"};
    }
    
    $xml.= qq{>$id_run</id_run>};
  }
  $xml .= q{</root>};


  my $web_target = q{run_graph};

  $self->web_request_by_xml($xml, $web_target);
 
  return;
}

sub instrument_statistics{

  my ($self, $id_run, $end) = @_;

  my $xml = q{<?xml version="1.0" encoding="utf-8"?><root><method>instrument_statistics</method>};
  if($id_run){
    $xml .= q{<id_run};

    if($end){
      $xml .= qq{ end="$end"};
    }else{
      $xml .= q{ end="1"};
    }
    
    $xml.= qq{>$id_run</id_run>};
  }
  $xml .= q{</root>};


  my $web_target = q{run_graph};

  $self->web_request_by_xml($xml, $web_target);
 
  return;
}

sub cache_query_movez_tiles{

  my ($self, $id_run, $to_update) = @_;
  my $xml = q{<?xml version="1.0" encoding="utf-8"?><root><method>cache_query_movez_tiles</method>};
  
  if($id_run){
    $xml .= q{<id_run};
    if($to_update == 1){
      $xml .= q{ update="yes"};
    }else{
      $xml .= q{ update="no"};
    }
    $xml.= qq{>$id_run</id_run>};
  }

  $xml    .=q{</root>};
  #print "$xml\n";
  my $web_target = q{cache_query};

  $self->web_request_by_xml($xml, $web_target);
 
  return;
}

sub cache_query_lane_summary{

  my ($self, $id_run, $end, $to_update) = @_;
  my $xml = q{<?xml version="1.0" encoding="utf-8"?><root><method>cache_query_lane_summary</method>};

   if($id_run){
    $xml .= q{<id_run};
    if($to_update == 1){
      $xml .= q{ update="yes"};
    }else{
      $xml .= q{ update="no"};
    }
    
    if($end){
      $xml .= qq{ end="$end"};
    }else{
      $xml .= q{ end="1"};
    }
     
    $xml.= qq{>$id_run</id_run>};
  }
  $xml    .=q{</root>};

  #print "$xml\n";

  my $web_target = q{cache_query};

  $self->web_request_by_xml($xml, $web_target);
 
  return;
}

sub web_request_by_xml {
    my ($self, $xml, $web_target) = @_;
    my $util = $self->util();

    my $response = $util->post(
      $util->base_uri().$web_target,
      [
         'Content_Type'   => 'application/xml',
  			'Content_Length' => length $xml,
  			'Content'        => $xml,
  			'Accept'         => 'text/xml',
      ]
    );

    if ($response->is_success()) {
      
      my $parser = $self->util->parser();
      my $statement = $parser->parse_string($response->content)->getElementsByTagName('response');

      if($statement !~ /success/xms){
        croak 'request not successfully';
      }else{
        print "web request successfully\n$statement\n" or croak "unable to print\n";
      }

    } else {
      croak 'failed to successfully post - this could be from a timeout issue';
    }

    return 1;
}

1;
__END__

=head1 NAME

npg_qc::api::run_caching

=head1 VERSION

$LastChangedRevision: 4034 $

=head1 SYNOPSIS

=head1 DESCRIPTION

=head1 SUBROUTINES/METHODS

=head2 cache_list_query_lane_summary - given a list of id_runs, cache each pair of runs for lane summary

=head2 cache_list_query_movez_tiles - given a list of id_runs, cache each run for movez tiles

=head2 cache_list_query_run_graph - given a list of id_runs, cache each pair of runs for run graph data

=head2 run_graph - send an xml request to the server to run all available run_graph calculate

=head2 cache_query_movez_tiles

=head2 cache_query_lane_summary

=head2 cache_all

=head2 web_request_by_xml - given xml string and web address, send the xml request to the server

=head2 instrument_statistics

=head1 DIAGNOSTICS

=head1 CONFIGURATION AND ENVIRONMENT

=head1 DEPENDENCIES

strict
warnings
Carp
English
npg_qc::api::base


=head1 INCOMPATIBILITIES

=head1 BUGS AND LIMITATIONS

=head1 AUTHOR

Andy Brown, E<lt>gq1@sanger.ac.ukE<gt>

=head1 LICENSE AND COPYRIGHT

Copyright (C) 2008 GRL, by Guoying Qi

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.4 or,
at your option, any later version of Perl 5 you may have available.

=cut
