#!/software/bin/perl -wT
#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-06-18
# Last Modified: $Date: 2009-01-30 12:32:35 +0000 (Fri, 30 Jan 2009) $
# Id:            $Id: npg_qc_api.pl 4105 2009-01-30 12:32:35Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/trunk/scripts/npg_qc_api.pl $
#

use strict;
use warnings;
use lib qw(/software/solexa/lib/site_perl);
use SangerPaths qw(core ensembl tracking trackingnpg badger);
use npg_qc::api::main;
use npg_qc::api::util;
use LWP::UserAgent;
use Carp;
use English qw{-no_match_vars};

our $VERSION = do { my ($r) = q$LastChangedRevision: 4105 $ =~ /(\d+)/mx; $r; };

$ENV{'PATH'} = join q(:), qw(/bin /usr/bin /usr/local/bin);

#$ENV{dev} = 'dev';

main();
0;

sub main {

  print qq{Processing...\n};

  #########
  # overide base uri for npg_qc
  my $uri  = q{http://intweb.sanger.ac.uk/cgi-bin/prodsoft/npg_qc/npg_qc/};
  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });

  ########
  # create main object
  my $api_main = npg_qc::api::main->new({util => $util});

  #######
  # set default expected paths for the GERALD folders with fuzzy matching
  $api_main->set_file_root(q{/});
  $api_main->set_file_dir(q{staging/IL*/outgoing/*run_no/Latest_Summary/});
  $api_main->set_file_ext(q{*txt});
  $api_main->set_summary_dir(q{staging/IL*/outgoing/*run_no/Latest_Summary/Summary.htm});
  $api_main->set_run_folder(q{staging/IL*/outgoing/*run_no}); 
  #$api_main->set_signal_mean_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*auto*/Bustard*auto/Signal_Means.txt});
  $api_main->set_score_dir(q{staging/IL*/outgoing/*run_no/Latest_Summary/Temp/});
  #$api_main->set_fastqcheck_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*auto*/archive/*fastqcheck});
  #$api_main->set_matrix_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*auto*/Matrix/s_*_*_matrix.txt});
  #$api_main->set_matrix_dir13(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*auto*/Bustard*auto/Matrix/s_*_*_matrix.txt});
  #$api_main->set_offset_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*auto*/Offsets/s_*_offsets.txt});

  print qq{Created workhorse successfully...\nAttempting to process Bustard output files (this may take a few minutes)...\n} or croak;

  #######
  # run main process_all_bustard file, evaluate and exit
  eval{
    $api_main->process_all_bustard();
  } or do {
    croak $EVAL_ERROR;
  };

  print qq{\nAll Files processed successfully.\n};
}
