#!/software/bin/perl -wT
##!/nfs/team117/gq1/dev/bin/perl -wT
#########
# Author:        gq1
# Maintainer:    $Author: gq1 $
# Created:       2008-07-23
# Last Modified: $Date: 2009-03-03 11:23:53 +0000 (Tue, 03 Mar 2009) $
# Id:            $Id: npg_qc_api_runlog.pl 4349 2009-03-03 11:23:53Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/trunk/scripts/npg_qc_api_runlog.pl $
#

use strict;
use warnings;
use lib qw(lib /software/solexa/lib/site_perl/);
use SangerPaths qw(core ensembl tracking trackingnpg badger);
use npg_qc::api::main;
use npg_qc::api::util;
use LWP::UserAgent;
use Carp;
use English qw{-no_match_vars};
use npg_qc::api::run_timeline;
use npg_qc::api::run_caching;
use npg_qc::api::run_recipe;

our $VERSION = do { my ($r) = q$LastChangedRevision: 4349 $ =~ /(\d+)/msx; $r; };

$ENV{'PATH'} = join q(:), qw(/bin /usr/bin /usr/local/bin);

#$ENV{dev} = 'dev';

main_run_timeline();

main_run_caching();

main_run_recipe();

main();


0;

sub main {
  print qq{*********\nProcessing runlog files...\n};
  #########
  # overide base uri for npg_qc
  #my $uri  = q{http://deskpro19635.dynamic.sanger.ac.uk:8080/cgi-bin/prodsoft/npg_qc/npg_qc/};
  my $uri  = q{http://intweb.sanger.ac.uk/cgi-bin/prodsoft/npg_qc/npg_qc/};

  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });
  ########
  # create main object
  my $api_main = npg_qc::api::main->new({util => $util});
  #######
  # set default expected paths for the GERALD folders with fuzzy matching
  $api_main->set_runlog_file_root('/staging');
  $api_main->set_runlog_file_outgoing('IL*/outgoing/*/RunLog_concat.xml');
  $api_main->set_runlog_file_analysis('IL*/analysis/*/RunLog_concat.xml');
  #######
  # run main process_all_bustard file, evaluate and exit
  eval{
    $api_main->process_all_runlog();
    1;
  } or do{
      croak $EVAL_ERROR;
  };
  print qq{All runlog files processed successfully.\n};
  return 1;
}

sub main_run_timeline{
  print qq{*********\nProcessing run timeline data...\n};

  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => undef,
    parser    => undef,
  });

  my $run_timeline_api = npg_qc::api::run_timeline->new({util => $util});

  eval{
    $run_timeline_api->save_all_runs_date();
    1;
  } or do {
    croak $EVAL_ERROR;
  };
  print qq{\nAll run timeline data processed successfully.\n};
  return 1;
}

sub main_run_caching {
  print qq{***********\nRun caching...\n};

  #########
  # overide base uri for npg_qc
  #my $uri  = q{http://deskpro19635.dynamic.sanger.ac.uk:8080/cgi-bin/prodsoft/npg_qc/npg_qc/};
  my $uri  = q{http://intweb.sanger.ac.uk/cgi-bin/prodsoft/npg_qc/npg_qc/};

  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });

  my $api_run_caching = npg_qc::api::run_caching->new({
                                       util => $util,
                                       });
  eval{
    $api_run_caching->cache_all();
    1;
  } or do{
    croak $EVAL_ERROR;
  };

  print "finish run caching\n";
  return 1;
}

sub main_run_recipe{
  print qq{*********\nProcessing run recipe data...\n};

  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => undef,
    parser    => undef,
  });

  my $run_recipe_api = npg_qc::api::run_recipe->new({util => $util});

  eval{
    $run_recipe_api->set_file_root(q{/});
    $run_recipe_api->set_file_outgoing('staging/IL*/outgoing/*_IL*_*/Recipe*.xml');
    $run_recipe_api->set_file_analysis('staging/IL*/analysis/*_IL*_*/Recipe*.xml');

    $run_recipe_api->process_all_runfolder();
    1;
  } or do {
    croak $EVAL_ERROR;
  };
  print qq{\nAll run recipe data processed successfully.\n};
  return 1;
}
