########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-10-06
# Last Modified: $Date: 2008-12-01 11:14:26 +0000 (Mon, 01 Dec 2008) $
# Id:            $Id: 30-api-analysis_loader.t 3636 2008-12-01 11:14:26Z ajb $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/trunk/t/30-api-analysis_loader.t $
#

use strict;
use warnings;
use Test::More 'no_plan'; #tests => 10;
use English qw(-no_match_vars);
use lib qw{t};
use SangerPaths qw(core ensembl);
use t::api::util;
use npg::api::util;
use t::useragent;
use DBI; # ARGH!
use Carp;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3636 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::api::analysis::loader');
{
  my $ua_mock = {
    q{http://localhost:8080/cgi-bin/prodsoft/npg/npg/}   => q{},
  };

  my $ua   = t::useragent->new({is_success => 1, mock => $ua_mock});
  my $npg_api_util = npg::api::util->new({useragent => $ua});
  my $util = t::api::util->new({dbh => undef, npg_api_util => $npg_api_util, fixtures => 1, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
  $util->load_fixtures();
  isa_ok($util->get_dbh(), q{DBI::db}, 'util has dbh');
  my $loader = npg_qc::api::analysis::loader->new({util => $util});

  isa_ok($loader, 'npg_qc::api::analysis::loader', '$loader');

  $loader->dbh($util->get_dbh());
  is($loader->dbh(), $util->get_dbh(), 'we have a connection to the test database');

  eval {
    $loader->process_run('t/data/staging/IL1/outgoing/080530_IL1_0956/Data/C2-37_Firecrest1.9.2_03-06-2008_auto/Bustard1.9.2_03-06-2008_auto/GERALD_03-06-2008_auto');
  };
  is($EVAL_ERROR, q{}, 'no croak on process_run');

  eval {
    $loader->process_run('t/data/staging/IL1/outgoing/foo_IL1_bar/Data/C2-37_Firecrest1.9.2_03-06-2008_auto/Bustard1.9.2_03-06-2008_auto/GERALD_03-06-2008_auto');
  };
  like($EVAL_ERROR, qr{Unable\ to\ determine\ run\ name\ from}, 'not well formed run name');
  eval {
    $loader->process_run('t/data/staging/IL17/analysis/080626_IL17_0956/Data/C1-74_Firecrest1.9.5_04-07-2008_auto/Bustard1.9.5_04-07-2008_auto/GERALD_04-07-2008_auto');
  };
  like($EVAL_ERROR, qr{No\ data\ processed\.\ Skipping}, 'No Summary.htm');
}
