#########
# Author:        gq1
# Maintainer:    $Author: gq1 $
# Created:       2008-07-18
# Last Modified: $Date: 2008-07-31 11:01:29 +0100 (Thu, 31 Jul 2008) $
# Id:            $Id: 30-api-process_runlog_z.t 2570 2008-07-31 10:01:29Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/branches/prerelease-1.0/t/30-api-process_runlog_z.t $
#

use strict;
use warnings;
use Test::More tests => 3;
use SangerPaths qw(ensembl core badger trackingnpg tracking);
use English qw(-no_match_vars);
use npg_qc::api::process::runlog_z3;

use t::api::util;

our $VERSION = do { my ($r) = q$LastChangedRevision: 2570 $ =~ /(\d+)/mx; $r; };

my $util = t::api::util->new({dbh => 'dummy', fixtures => 0, useragent => 0, parser => 0, base_uri => 0});

use_ok('npg_qc::api::process::runlog_z3');

{
  my $runlog_z_1 = npg_qc::api::process::runlog_z3->new({util => $util});  
  $runlog_z_1->process_id_run('t/data/staging/IL16/outgoing/080619_IL16_0917/RunLog_concat.xml');
  is($runlog_z_1->get_id_run(), 917, "get correct id_run from runlog xml file path");

}
{
  my $runlog_z_2 = npg_qc::api::process::runlog_z3->new({util => $util});  
  ok($runlog_z_2->extract_movez('t/data/staging/IL16/outgoing/080619_IL16_0917/RunLog_concat.xml'), 'extract xml');
  my $xml_list = $runlog_z_2->get_xml_list_movez();
  foreach my $xml (@{$xml_list}){
    #print $xml;
  }

}
1;
