########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-10-06
# Last Modified: $Date: 2008-12-12 12:07:02 +0000 (Fri, 12 Dec 2008) $
# Id:            $Id: 30-api-summary_lane_qc_loader.t 3770 2008-12-12 12:07:02Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/trunk/t/30-api-summary_lane_qc_loader.t $
#

use strict;
use warnings;
use Test::More 'no_plan';#tests => 12;
use English qw(-no_match_vars);
use lib qw{t};
use SangerPaths qw(core ensembl);
use t::api::util;
use npg::api::util;
use t::useragent;
use DBI; # ARGH!
use Carp;
use Perl6::Slurp;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3770 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::api::loader');
use_ok('npg_qc::api::loader::summary_data');

my $ua   = t::useragent->new({is_success => 1, mock => {}});
my $npg_api_util = npg::api::util->new({useragent => $ua});
my $util = t::api::util->new({dbh => undef, npg_api_util => $npg_api_util, fixtures => 1, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
$util->load_fixtures();
my $test_dbh = $util->get_dbh();
isa_ok($test_dbh, q{DBI::db}, 'util has dbh');

my $summary_xml = slurp 't/data/rendered/summary.xml';

my $loader = npg_qc::api::loader::summary_data->new({ xml => $summary_xml, util => $util });
isa_ok($loader, q{npg_qc::api::loader::summary_data}, '$loader');
is($loader->util(), $util, '$loader has test util');
is($loader->get_xml(), $summary_xml, 'xml stored in object ok');

my $before_save_lane_qc_rows;
eval { $before_save_lane_qc_rows = $test_dbh->selectall_arrayref(q{SELECT * FROM lane_qc}, {}); } or do { warn "Something went wrong"; };
my $before_save_chip_summary;
eval { $before_save_chip_summary = $test_dbh->selectall_arrayref(q{SELECT * FROM chip_summary}, {}); } or do { warn "Something went wrong"; };

$loader->dbh($test_dbh);
is($loader->dbh(), $test_dbh, 'test_dbh being used');

eval { $loader->read_xml(); } or do { warn "Something croaked\n\t$EVAL_ERROR\n";};
is($EVAL_ERROR, q{}, 'no croak on read_xml');

my $after_save_chip_summary;
eval { $after_save_chip_summary = $test_dbh->selectall_arrayref(q{SELECT * FROM chip_summary}, {}); } or do { warn "Something went wrong"; };


my $before_chip_count = scalar @{$before_save_chip_summary};
my $after_chip_count = scalar @{$after_save_chip_summary};
is($after_chip_count, $before_chip_count + 1, 'one more row in database for chip_summary'); 
my $after_save_lane_qc_rows;
eval { $after_save_lane_qc_rows = $test_dbh->selectall_arrayref(q{SELECT * FROM lane_qc}, {}); } or do { warn "Something went wrong"; };

my $before_lqc_count = scalar @{$before_save_lane_qc_rows};
my $after_lqc_count = scalar @{$after_save_lane_qc_rows};
is($after_lqc_count, $before_lqc_count + 5280, '5280 more row in database for lqc'); 

eval { $loader->read_xml(); } or do { warn "Something croaked\n\t$EVAL_ERROR\n";};
is($EVAL_ERROR, q{}, 'no croak on read_xml, even though duplicate entry croak on dbh insertion of chip summary');
__END__
